## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_without check

%if 0%{?rhel}
%global bundled_rust_deps 1
%else
%global bundled_rust_deps 0
%endif

%global tarball_version %%(echo %{version} | tr '~' '.')

Name:           snapshot
Version:        48.0.1
Release:        %autorelease
Summary:        Take pictures and videos

# snapshot: GPL-3.0-or-later
# Rust dependencies:
# (MIT OR Apache-2.0) AND ISC
# (MIT OR Apache-2.0) AND Unicode-3.0
# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSD-2-Clause OR Apache-2.0 OR MIT
# GPL-3.0-or-later
# ISC
# MIT
# MIT OR Apache-2.0
# MPL-2.0 OR LGPL-2.1-or-later
# Unlicense OR MIT
# Zlib
# Zlib OR Apache-2.0 OR MIT
License:        %{shrink:
    GPL-3.0-or-later AND
    ISC AND
    MIT AND
    Unicode-3.0 AND
    Unicode-DFS-2016 AND
    Zlib AND
    (Apache-2.0 OR MIT) AND
    (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND
    (BSD-2-Clause OR Apache-2.0 OR MIT) AND
    (MPL-2.0 OR LGPL-2.1-or-later) AND
    (Unlicense OR MIT) AND
    (Zlib OR Apache-2.0 OR MIT)
}
# LICENSE.dependencies contains a full license breakdown
URL:            https://gitlab.gnome.org/GNOME/snapshot
Source:         https://download.gnome.org/sources/snapshot/48/snapshot-%{tarball_version}.tar.xz

# Downstream patch to disable linting as part of self tests
Patch:          0001-Disable-cargo-clippy-test.patch

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

%if 0%{?rhel}
BuildRequires:  rust-toolset
%else
BuildRequires:  cargo-rpm-macros
%endif
BuildRequires:  meson
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  pkgconfig(gstreamer-plugins-bad-1.0)
BuildRequires:  pkgconfig(gstreamer-video-1.0)
BuildRequires:  pkgconfig(gtk4)
BuildRequires:  pkgconfig(libadwaita-1)
BuildRequires:  pkgconfig(libseccomp)
BuildRequires:  /usr/bin/appstream-util
BuildRequires:  /usr/bin/desktop-file-validate

# For camerabin GStreamer element
Requires:       gstreamer1-plugins-bad-free%{_isa}
# For gtk4 GStreamer element
Requires:       gstreamer1-plugin-gtk4%{_isa}
# Image loaders used by snapshot
Requires:       glycin-loaders >= 1.1
# For hicolor icon theme directories
Requires:       hicolor-icon-theme

Provides:       bundled(crate(aperture)) = 0.7.0

%description
Take pictures and videos on your computer, tablet, or phone.


%prep
%autosetup -p1 -n snapshot-%{tarball_version}

%if 0%{?bundled_rust_deps}
%cargo_prep -v vendor
%else
rm -rf vendor
%cargo_prep
%endif


%if ! 0%{?bundled_rust_deps}
%generate_buildrequires
%cargo_generate_buildrequires -a
cd aperture
%cargo_generate_buildrequires -a
cd ~-
%endif


%build
%meson
%meson_build

%cargo_license_summary
%{cargo_license} > LICENSE.dependencies
%if 0%{?bundled_rust_deps}
%cargo_vendor_manifest
%endif


%install
%meson_install

%find_lang snapshot --with-gnome


%if %{with check}
%check
%meson_test \
%ifarch riscv64
    --timeout-multiplier 10 \
%endif
    %{nil}

appstream-util validate-relax --nonet $RPM_BUILD_ROOT%{_metainfodir}/org.gnome.Snapshot.metainfo.xml
desktop-file-validate $RPM_BUILD_ROOT%{_datadir}/applications/org.gnome.Snapshot.desktop
%endif


%files -f snapshot.lang
%license LICENSE
%license LICENSE.dependencies
%if 0%{?bundled_rust_deps}
%license cargo-vendor.txt
%endif
%doc README.md
%{_bindir}/snapshot
%{_datadir}/applications/org.gnome.Snapshot.desktop
%{_datadir}/glib-2.0/schemas/org.gnome.Snapshot.gschema.xml
%{_datadir}/icons/hicolor/scalable/apps/org.gnome.Snapshot*.svg
%{_datadir}/icons/hicolor/symbolic/apps/org.gnome.Snapshot-symbolic.svg
%{_datadir}/snapshot/
%{_metainfodir}/org.gnome.Snapshot.metainfo.xml


%changelog
## START: Generated by rpmautospec
* Mon Mar 24 2025 Fabio Valentini <decathorpe@gmail.com> - 48.0.1-1
- Update to version 48.0.1; Fixes RHBZ#2332394

* Wed Mar 12 2025 Gwyn Ciesla <gwync@protonmail.com> - 47.1-4
- gstreamer1-plugins-bad-free rebuild

* Sun Jan 19 2025 Fedora Release Engineering <releng@fedoraproject.org> - 47.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Wed Nov 20 2024 nmontero <nmontero@redhat.com> - 47.1-2
- Add Packit configuration for automating release syncing

* Mon Oct 14 2024 nmontero <nmontero@redhat.com> - 47.1-1
- Update to 47.1

* Mon Oct 07 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 47.0.1-2
- Add libseccomp dependency

* Mon Sep 30 2024 Fabio Valentini <decathorpe@gmail.com> - 47.0.1-1
- Update to version 47.0.1; Fixes RHBZ#2295571

* Sat Jul 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 46.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sat May 25 2024 Fabio Valentini <decathorpe@gmail.com> - 46.3-3
- Rebuild for gstreamer-plugins-bad 1.24

* Fri May 24 2024 Fabio Valentini <decathorpe@gmail.com> - 46.3-2
- Rebuild with Rust 1.78 to fix incomplete debuginfo and backtraces

* Tue May 07 2024 David King <amigadave@amigadave.com> - 46.3-1
- Update to 46.3

* Thu Apr 18 2024 David King <amigadave@amigadave.com> - 46.2-1
- Update to 46.2

* Tue Apr 09 2024 Adam Williamson <awilliam@redhat.com> - 46.1-3
- Backport caps preference fix, disable portal usage

* Tue Apr 02 2024 Fabio Valentini <decathorpe@gmail.com> - 46.1-2
- Revert to de-vendoring dependencies on Fedora

* Mon Apr 01 2024 David King <amigadave@amigadave.com> - 46.1-1
- Update to 46.1

* Wed Mar 27 2024 David King <amigadave@amigadave.com> - 46.0-1
- Update to 46.0

* Thu Feb 22 2024 Adam Williamson <awilliam@redhat.com> - 45.2-7
- Rediff #201 patch on 45.2

* Thu Feb 22 2024 Adam Williamson <awilliam@redhat.com> - 45.2-6
- Actually put the MR #201 patch in the spec

* Tue Feb 20 2024 David Abdurachmanov <davidlt@rivosinc.com> - 45.2-5
- Use timeout multiplier for riscv64

* Mon Feb 19 2024 Adam Williamson <awilliam@redhat.com> - 45.2-4
- Backport MR #201 to try and fix startup

* Thu Feb 01 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 45.2-3
- Update Rust macro usage

* Sat Jan 27 2024 Fedora Release Engineering <releng@fedoraproject.org> - 45.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Dec 27 2023 Kalev Lember <klember@redhat.com> - 45.2-1
- Update to 45.2

* Sat Dec 09 2023 Kalev Lember <klember@redhat.com> - 45.1-1
- Update to 45.1

* Wed Nov 15 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 45.0-6
- Fix RHEL build

* Wed Nov 15 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 45.0-5
- Fix build with appstream 1.0

* Fri Oct 06 2023 Kalev Lember <klember@redhat.com> - 45.0-4
- Backport upstream MR !168 to fix portal requests

* Mon Oct 02 2023 Kalev Lember <klember@redhat.com> - 45.0-3
- Use bundled rust deps on RHEL

* Sun Oct 01 2023 Kalev Lember <klember@redhat.com> - 45.0-2
- Package review fixes (rhbz#2241553)
- Add SourceLicense tag to distinguish between the license of the app
  itself and its crate deps
- Slightly change virtual provides for bundled aperture crate to better
  match other rust packages

* Sun Oct 01 2023 Kalev Lember <klember@redhat.com> - 45.0-1
- Initial Fedora packaging (rhbz#2241553)
## END: Generated by rpmautospec
